# PanguLU

 
 **PanguLU** is an open source software package that uses a block sparse structure to solve linear systems A*X=B. It uses a sparse matrix block LU decomposition algorithm. The sparse matrix block LU decomposition algorithm is an algorithm that splits the sparse matrix into multiple sparse matrix blocks, and uses sflu, sparse triangle solution sptrsv, sparse matrix matrix multiplication spgemm and other kernels among the sparse matrix blocks. The algorithm can be used in heterogeneous The distributed platform operates accurately and efficiently.

-------------------


## Introduction

PanguLU is mainly deployed at distributed multi-GPU parallel clusters. PanguLU is implemented in the use of MPI and CUDA,  MPI is used for communication and CUDA is used for GPU computing . We have implemented multi-GPU acceleration and are still actively accelerating.

PanguLU reads in a CSR matrix that has undergone symbolic decomposition, then performs matrix division, distributes the matrix to each node for numerical decomposition, and then solves the vector through distributed triangular solution. 


## Structure of code

```
PanguLU/README      instructions on installation
PanguLU/src         C and CUDA source code, to be compiled into libpangulu.so
PanguLU/test        testing code
PanguLU/lib         contains library archieve libpangulu.so
PanguLU/Makefile    top-level Makefile that does installation and testing
PanguLU/make.inc    compiler, compiler flags included in all Makefiles

```

## Installation
we use the method is to use make automatic build system.
installation method:
You will need install make.
Frist, in order to use MPI, you need to install mpich (recommended version: mpich-3.3.2).
Second, in order to use NVCC, you need to install CUDA (recommended version: CUDA-11.3).
Third,Specify the installation path to be used in make.inc.
Fianlly, use make for automatic installation.
> **make**

## Execution of PanguLU
PanguLU is to complete the operation of solving AX=b, and the test file is placed in the test folder. The test is to first perform the LU numerical decomposition of the matrix test.mtx, and use Ly=b to complete the lower triangular solution and Ux=y to complete the upper triangular solution test method.
### run command

> **mpirun  -np process_number ./PanguLU  -NB NB_number -P P_number -Q Q_number -F Smatrix_name**
 
process_number:this process number 
NB_number:the number of processes required is equal to the product of P and Q;
 P_number:the number of process grid rows;
 Q_number:the number of process grid columns;
 Smatrix_name:the Matrix name in csr format.(This matrix needs to be decomposed symbolically)
 
### test sample

> **mpirun -np 6 ./PanguLU  -NB 2 -P 2 -Q 3 -F test.mtx**

In this example,six processes are used to test, the  NB_number is 2 ,P_number is 2,Q_number is 3, matrix name is test.mtx
## Release version
Oct 19,2021 Version Beta

 





