#ifndef PANGULU_GESSM_FP64_H
#define PANGULU_GESSM_FP64_H
#ifdef __cplusplus
extern "C"
{
#endif
#include "pangulu_common.h"
#include "pangulu_cuda_interface.h"
    /*
The function in this file is primarily called kernel,these functions would be called in pangulu_kernel_interface.h
*/
    void pangulu_gessm_fp64(pangulu_Smatrix *A,
                            pangulu_Smatrix *L,
                            pangulu_Smatrix *X)
    {
        pangulu_cuda_memcpy_value_device_to_host(A);
        pangulu_transport_pangulu_Smatrix_CSR_to_CSC(L);
        int *A_rowpointer = A->rowpointer;
        int *A_colindex=A->columnindex;
        calculate_type *A_value = A->value;
        int *L_colpointer = L->columnpointer;
        int *L_rowindex = L->rowindex;
        calculate_type *L_value = L->value_CSC;
        int *X_rowpointer = X->rowpointer;
        int *X_colindex=X->columnindex;
        calculate_type *X_value = X->value;
        int n = A->row;

        for(int i=0;i<n;i++){
            L_value[L_colpointer[i]]=1.0;
        }

        for (int i = 0; i < n; i++)
        {
            //X get value from A
            for (int k = X_rowpointer[i]; k < X_rowpointer[i + 1]; k++)
            {
                X_value[k] = A_value[k];
            }
            //update Value
            if (X_rowpointer[i] != X_rowpointer[i + 1])
                for (int j = L_colpointer[i]; j < L_colpointer[i + 1]; j++)
                {

                    for (int p = A_rowpointer[L_rowindex[j]], k = X_rowpointer[i]; p < A_rowpointer[L_rowindex[j] + 1]; p++, k++)
                    {
                        if(A_colindex[p] == X_colindex[k]){
                            A_value[p] -= L_value[j] * X_value[k];
                        }
                        else{
                            k--;
                        }
                    }
                }
        }
    }

#ifdef __cplusplus
}
#endif

#endif