#ifndef PANGULU_GETRF_FP64_H
#define PANGULU_GETRF_FP64_H
#ifdef __cplusplus
extern "C"
{
#endif
#include "pangulu_common.h"
    /*
The function in this file is primarily called kernel,these functions would be called in pangulu_kernel_interface.h
*/
    void pangulu_getrf_fp64(pangulu_Smatrix *A,
                            pangulu_Smatrix *L,
                            pangulu_Smatrix *U)
    {
        int n = A->row;
        calculate_type *dense_matrix_L = (calculate_type *)malloc(sizeof(calculate_type) * n * n);
        calculate_type *dense_matrix_U = (calculate_type *)malloc(sizeof(calculate_type) * n * n);
        calculate_type *dense_matrix_A = (calculate_type *)malloc(sizeof(calculate_type) * n * n);
        pangulu_pangulu_Smatrix_to_dense_matrix(dense_matrix_A, A, n);
        for (int i = 0; i < n; i++)
        {
            //calculate_type pivot = 1.0;
            calculate_type pivot = dense_matrix_A[i * n + i];
            for (int j = i + 1; j < n; j++)
            {
                if (pivot > ERROR || pivot < -ERROR)
                {
                }
                else
                {
                    pivot = ERROR;
                }
                calculate_type scale = -dense_matrix_A[j * n + i] / pivot;
                dense_matrix_A[j * n + i] = -scale;
                for (int x = i + 1; x < n; x++)
                {
                    dense_matrix_A[j * n + x] += scale * dense_matrix_A[i * n + x];
                }
            }
        }
        memset(dense_matrix_L, 0.0, sizeof(calculate_type) * n * n);
        memset(dense_matrix_U, 0.0, sizeof(calculate_type) * n * n);
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
            {
                if (i > j)
                    dense_matrix_L[i * n + j] = dense_matrix_A[i * n + j];
                else
                    dense_matrix_U[i * n + j] = dense_matrix_A[i * n + j];
                if (i == j)
                {
                    dense_matrix_L[i * n + j] = 1;
                }
            }
        }
        pangulu_dense_matrix_to_pangulu_Smatrix(L, dense_matrix_L, n);
        pangulu_dense_matrix_to_pangulu_Smatrix(U, dense_matrix_U, n);
        free(dense_matrix_L);
        free(dense_matrix_U);
        free(dense_matrix_A);
    }
#ifdef __cplusplus
}
#endif

#endif