#ifndef PANGULU_GETRF_FP64_CUDA
#define PANGULU_GETRF_FP64_CUDA
#ifdef __cplusplus
extern "C"
{
#endif
#include "pangulu_common.h"
#include "pangulu_cuda.h"
#include "pangulu_cuda_interface.h"
    /*
The function in this file is primarily called kernel,these functions would be called in pangulu_kernel_interface.h
*/
    void pangulu_getrf_fp64_cuda(pangulu_Smatrix *A,
                                 pangulu_Smatrix *L,
                                 pangulu_Smatrix *U)
    {
        pangulu_cuda_transport_CSR_to_CSC(A);
        pangulu_getrf_cuda_kernel(A->row,
                                  A->rowpointer[A->row],
                                  U->CUDA_nnzU,
                                  A->CUDA_columnpointer,
                                  A->CUDA_rowindex,
                                  A->CUDA_value_CSC,
                                  L->CUDA_columnpointer,
                                  L->CUDA_rowindex,
                                  L->CUDA_value_CSC,
                                  U->CUDA_columnpointer,
                                  U->CUDA_rowindex,
                                  U->CUDA_value_CSC);
        pangulu_cuda_transport_CSC_to_CSR(L);
        pangulu_cuda_transport_CSC_to_CSR(U);
        pangulu_cuda_memcpy_value_device_to_host(L);
        pangulu_cuda_memcpy_value_device_to_host(U);
    }
    
#ifdef __cplusplus
}
#endif

#endif