#ifndef PANGULU_KERNEL_INTERFACE_H
#define PANGULU_KERNEL_INTERFACE_H
#ifdef __cplusplus
extern "C"
{
#endif
#include "pangulu_common.h"
#include "pangulu_getrf_fp64.h"
#include "pangulu_getrf_fp64_cuda.h"
#include "pangulu_tstrf_fp64.h"
#include "pangulu_tstrf_fp64_cuda.h"
#include "pangulu_gessm_fp64.h"
#include "pangulu_gessm_fp64_cuda.h"
#include "pangulu_ssssm_fp64.h"
#include "pangulu_ssssm_fp64_cuda.h"
    /*
The function in this file is primarily called kernel,these functions would be called in pangulu_numerical.h
*/
    void pangulu_getrf_interface(pangulu_Smatrix *A,
                                 pangulu_Smatrix *L,
                                 pangulu_Smatrix *U)
    {
        pangulu_getrf_fp64_cuda(A, L, U);
    }

    void pangulu_tstrf_interface(pangulu_Smatrix *A,
                                 pangulu_Smatrix *X,
                                 pangulu_Smatrix *U)
    {
#ifdef CUDA_TSTRF
        pangulu_tstrf_fp64_cuda(A, X, U);

#else
    pangulu_tstrf_fp64(A, X, U);
#endif
    }

    void pangulu_gessm_interface(pangulu_Smatrix *A,
                                 pangulu_Smatrix *L,
                                 pangulu_Smatrix *X)
    {

#ifdef CUDA_GESSM
        pangulu_gessm_fp64_cuda(A, L, X);
#else
    pangulu_gessm_fp64(A, L, X);
#endif
    }

    void pangulu_ssssm_interface(pangulu_Smatrix *A,
                                 pangulu_Smatrix *L,
                                 pangulu_Smatrix *U)
    {
        pangulu_ssssm_fp64_cuda(A, L, U);
    }

#ifdef __cplusplus
}
#endif

#endif