#ifndef PANGULU_TSTRF_FP64_H
#define PANGULU_TSTRF_FP64_H
#ifdef __cplusplus
extern "C"
{
#endif
#include "pangulu_common.h"
#include "pangulu_cuda_interface.h"
    /*
The function in this file is primarily called kernel,these functions would be called in pangulu_kernel_interface.h
*/
    void pangulu_tstrf_fp64(pangulu_Smatrix *A,
                            pangulu_Smatrix *X,
                            pangulu_Smatrix *U)
    {
        pangulu_cuda_memcpy_value_device_to_host(A);
        pangulu_transport_pangulu_Smatrix_CSR_to_CSC(X);
        int *X_colpointer = X->columnpointer;
        int *X_rowindex = X->rowindex;
        calculate_type *X_value = X->value_CSC;
        int *U_rowpointer = U->rowpointer;
        int *U_columnindex = U->columnindex;
        calculate_type *U_value = U->value;
        pangulu_transport_pangulu_Smatrix_CSR_to_CSC(A);
        int *A_colpointer = A->columnpointer;
        int *A_rowindex = A->rowindex;
        calculate_type *A_value = A->value_CSC;
        int n = A->row;
        for (int i = 0; i < n; i++)
        {
            calculate_type t = U_value[U_rowpointer[i]];
            for (int k = A_colpointer[i]; k < A_colpointer[i + 1]; k++)
            {
                X_value[k] = A_value[k] / t;
            }
            //update Value
            if (A_colpointer[i] != A_colpointer[i + 1])
                for (int k = U_rowpointer[i]; k < U_rowpointer[i + 1]; k++)
                {
                    int p = X_colpointer[i];
                    for (int s = A_colpointer[U_columnindex[k]]; s < A_colpointer[U_columnindex[k] + 1]; s++)
                    {
                        if (X_rowindex[p] == A_rowindex[s])
                        {
                            A_value[s] -= X_value[p] * U_value[k];
                            p++;
                        }
                        else
                        {
                            continue;
                        }
                    }
                }
        }
        pangulu_transport_pangulu_Smatrix_CSC_to_CSR(X);
    }
#ifdef __cplusplus
}
#endif

#endif